SystemOrganization addCategory: #Meta!

Object subclass: #UtilidadDeComposicion
	instanceVariableNames: ''
	classVariableNames: 'utilidadDeComposicion'
	poolDictionaries: ''
	category: 'Meta'!

!UtilidadDeComposicion class methodsFor: 'as yet unclassified' stamp: 'Edu 5/3/2013 13:52'!
new
	utilidadDeComposicion	ifNil:[utilidadDeComposicion := super new].
	^utilidadDeComposicion.! !

!UtilidadDeComposicion methodsFor: 'as yet unclassified' stamp: 'Edu 5/3/2013 16:52'!
agregarMetodosRedefinidos: metodosRedefinidos DeLaClase: unaClase aLaComposicion: unaClaseComposicion

	metodosRedefinidos do: [:metodoRedefinido | 
		unaClaseComposicion methodDictionary at: metodoRedefinido put: (unaClase methodDictionary at: metodoRedefinido).
		unaClase removeSelector: metodoRedefinido.].! !

!UtilidadDeComposicion methodsFor: 'as yet unclassified' stamp: 'Edu 5/3/2013 16:53'!
algunasSubclasesDe: unaClase Redefinen: unMetodo

	^(unaClase subclasses anySatisfy:  [: unaSubclase | unaSubclase methodDictionary keys includes: unMetodo]).! !

!UtilidadDeComposicion methodsFor: 'as yet unclassified' stamp: 'Edu 5/3/2013 13:41'!
cambiarHerenciaPorComposicion: unaClase conElNombre: nombreComposicion

	|metodosRedefinidos claseComposicion nombreComposicionProcesado|
	
	(unaClase allSubclasses size = 0) ifTrue: [ ^false ].
	
	metodosRedefinidos := self metodosRedefinidosPorAlgunasDeTodasLasSubclasesDe: unaClase.
	
	claseComposicion := self crearClaseComposicionAPartirDe: unaClase conElNombre: nombreComposicion.
	
	self agregarMetodosRedefinidos: metodosRedefinidos DeLaClase: unaClase aLaComposicion: claseComposicion. 		
	self hacerHeredarSubclasesDe: unaClase De: claseComposicion. 
	
	nombreComposicionProcesado := (nombreComposicion,'Composicion') asLegalSelector.
	
	unaClase addInstVarNamed:  nombreComposicionProcesado.
	
	self crearAccesorsPara: nombreComposicionProcesado De: unaClase.	
	
	self reemplazarLlamadasAMetodos: metodosRedefinidos En: unaClase.
	
	^true.! !

!UtilidadDeComposicion methodsFor: 'as yet unclassified' stamp: 'Edu 5/3/2013 13:31'!
crearAccesorsPara: unAtributo De: unaClase
	unaClase compile: unAtributo,': ',unAtributo,'Atributo
	',unAtributo,' := ',unAtributo,'Atributo.'.
unaClase compile: unAtributo,'
	^',unAtributo,'.'.! !

!UtilidadDeComposicion methodsFor: 'as yet unclassified' stamp: 'Edu 5/2/2013 15:52'!
crearClaseComposicionAPartirDe: unaClase conElNombre: nombreComposicion 

	^
	Object subclass: (nombreComposicion,'Composicion') asSymbol
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: unaClase category.! !

!UtilidadDeComposicion methodsFor: 'as yet unclassified' stamp: 'Edu 5/1/2013 19:58'!
hacerHeredarSubclasesDe: unaClase De: claseComposicion
	
	unaClase subclasses do: [:subclase | claseComposicion subclass: (subclase name asSymbol)
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: subclase category].! !

!UtilidadDeComposicion methodsFor: 'as yet unclassified' stamp: 'Edu 5/2/2013 18:15'!
metodosRedefinidosPorAlgunasDeTodasLasSubclasesDe: unaClase
	|metodos nombreComposicion|
			
	metodos := unaClase methodDictionary keys.
	
	^metodos select: [ :unMetodo | self algunasSubclasesDe: unaClase Redefinen: unMetodo].
	
	
	! !

!UtilidadDeComposicion methodsFor: 'as yet unclassified' stamp: 'Edu 5/3/2013 12:34'!
reemplazarLlamadasAMetodos: metodosEliminados De: unMetodoCodigo
	
	|metodoCodigo metodoEliminadoProcesado|
	
	metodoCodigo := unMetodoCodigo.

	metodosEliminados do: [:metodoEliminado |
		 metodoEliminadoProcesado := ('\w+' asRegex matchesIn: metodoEliminado) at: 1.
		 metodoCodigo := metodoCodigo copyWithRegex: metodoEliminadoProcesado matchesReplacedWith: ('composicion ',metodoEliminadoProcesado)].
	
	^metodoCodigo.! !

!UtilidadDeComposicion methodsFor: 'as yet unclassified' stamp: 'Edu 5/2/2013 03:37'!
reemplazarLlamadasAMetodos: metodosEliminados En: unaClase

	(unaClase methodDictionary values) do: [:metodoRestante | unaClase compile: 
		(self reemplazarLlamadasAMetodos: metodosEliminados De: (metodoRestante getSource))].! !

TestCase subclass: #TestUtilidadDeComposicion
	instanceVariableNames: 'claseAbstracta subClase1 subClase2 subClase3 utilidadComposicion'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Meta'!

!TestUtilidadDeComposicion methodsFor: 'accessing' stamp: 'Edu 5/2/2013 16:53'!
claseAbstracta
	^ claseAbstracta! !

!TestUtilidadDeComposicion methodsFor: 'accessing' stamp: 'Edu 5/2/2013 16:53'!
claseAbstracta: anObject
	claseAbstracta := anObject! !

!TestUtilidadDeComposicion methodsFor: 'as yet unclassified' stamp: 'Edu 5/2/2013 17:56'!
setUp
	self claseAbstracta: (Object subclass: #ClaseAbstracta instanceVariableNames: '' classVariableNames: '' poolDictionaries: '' category: 'Meta').
	
	self subclase1: (self claseAbstracta subclass: #SubClase1 instanceVariableNames: '' classVariableNames: '' poolDictionaries: '' category: 'Meta').
	
	self subclase2: (self claseAbstracta subclass: #SubClase2 instanceVariableNames: '' classVariableNames: '' poolDictionaries: '' category: 'Meta').
	
	self subclase3: (self claseAbstracta subclass: #SubClase3 instanceVariableNames: '' classVariableNames: '' poolDictionaries: '' category: 'Meta').
	
	self utilidadComposicion: UtilidadDeComposicion new.

! !

!TestUtilidadDeComposicion methodsFor: 'accessing' stamp: 'Edu 5/2/2013 17:24'!
subclase1
	^ subClase1! !

!TestUtilidadDeComposicion methodsFor: 'accessing' stamp: 'Edu 5/2/2013 17:24'!
subclase1: anObject
	subClase1 := anObject! !

!TestUtilidadDeComposicion methodsFor: 'accessing' stamp: 'Edu 5/2/2013 17:25'!
subclase2
	^ subClase2! !

!TestUtilidadDeComposicion methodsFor: 'accessing' stamp: 'Edu 5/2/2013 17:25'!
subclase2: anObject
	subClase2 := anObject! !

!TestUtilidadDeComposicion methodsFor: 'accessing' stamp: 'Edu 5/2/2013 17:25'!
subclase3
	^ subClase3! !

!TestUtilidadDeComposicion methodsFor: 'accessing' stamp: 'Edu 5/2/2013 17:25'!
subclase3: anObject
	subClase3 := anObject! !

!TestUtilidadDeComposicion methodsFor: 'as yet unclassified' stamp: 'Edu 5/3/2013 09:48'!
tearDown 
	self claseAbstracta removeFromSystem.
	self subclase1 removeFromSystem.
	self subclase2 removeFromSystem.
	self subclase3 removeFromSystem.! !

!TestUtilidadDeComposicion methodsFor: 'as yet unclassified' stamp: 'Edu 5/3/2013 10:41'!
testAgregarMetodosRedefinidosALaClaseDeComposicion
	|metodosRedefinidos claseComposicion|
		
	self claseAbstracta compile: 
		'metodo1 "Codigo metodo1 claseAbstracta"'.
		
	self claseAbstracta compile: 
		'metodo2 "Codigo metodo2 claseAbstracta"'.
	
	self claseAbstracta compile: 
		'metodo3 "Codigo metodo3 claseAbstracta"'.
	
	self claseAbstracta compile: 
		'metodo4 "Codigo metodo4 claseAbstracta"'.
		
	self claseAbstracta compile: 
		'metodo5 "Codigo metodo5 claseAbstracta"'.
	
	self subclase1 compile: 
		'metodo1 "Codigo metodo1 subClase1"'.
		
	self subclase1 compile: 
		'metodo8 "Codigo metodo8 subClase1"'.
		
	self subclase1 compile: 
		'metodo6 "Codigo metodo6 subClase1"'.

	self subclase2 compile: 
		'metodo3 "Codigo metodo3 subClase2"'.
		
	self subclase2 compile: 
		'metodo7 "Codigo metodo7 subClase2"'.

	self subclase3 compile: 
		'metodo1 "Codigo metodo1 subClase3"'.
		
	self subclase3 compile: 
		'metodo8 "Codigo metodo8 subClase3"'.

	metodosRedefinidos := self utilidadComposicion metodosRedefinidosPorAlgunasDeTodasLasSubclasesDe: self claseAbstracta.
	
	claseComposicion := self utilidadComposicion crearClaseComposicionAPartirDe: self claseAbstracta  conElNombre: 'Composicion'.
	
	self utilidadComposicion agregarMetodosRedefinidos: metodosRedefinidos  DeLaClase: self claseAbstracta aLaComposicion: claseComposicion.
	
	self assert: (claseComposicion methodDictionary size = 2).
	self assert: ((claseComposicion methodDictionary at: #metodo1) getSource = 'metodo1 "Codigo metodo1 claseAbstracta"').
	self assert: ((claseComposicion methodDictionary at: #metodo3) getSource = 'metodo3 "Codigo metodo3 claseAbstracta"').
	
	claseComposicion removeFromSystem.
	
	self assert: (self claseAbstracta methodDictionary size = 3).
	self assert: ((self claseAbstracta methodDictionary at: #metodo2) getSource = 'metodo2 "Codigo metodo2 claseAbstracta"').
	self assert: ((self claseAbstracta methodDictionary at: #metodo4) getSource = 'metodo4 "Codigo metodo4 claseAbstracta"').
	self assert: ((self claseAbstracta methodDictionary at: #metodo5) getSource = 'metodo5 "Codigo metodo5 claseAbstracta"').
	
	
! !

!TestUtilidadDeComposicion methodsFor: 'as yet unclassified' stamp: 'Edu 5/3/2013 10:59'!
testAgregarMetodosRedefinidosVaciosALaClaseDeComposicion
	|metodosRedefinidos claseComposicion|
		
	self claseAbstracta compile: 
		'metodo1 "Codigo metodo1 claseAbstracta"'.
		
	self claseAbstracta compile: 
		'metodo2 "Codigo metodo2 claseAbstracta"'.
	
	self claseAbstracta compile: 
		'metodo3 "Codigo metodo3 claseAbstracta"'.
	
	self claseAbstracta compile: 
		'metodo4 "Codigo metodo4 claseAbstracta"'.
		
	self claseAbstracta compile: 
		'metodo5 "Codigo metodo5 claseAbstracta"'.
	
	self subclase1 compile: 
		'metodo10 "Codigo metodo10 subClase1"'.
		
	self subclase1 compile: 
		'metodo8 "Codigo metodo8 subClase1"'.
		
	self subclase1 compile: 
		'metodo6 "Codigo metodo6 subClase1"'.

	self subclase2 compile: 
		'metodo9 "Codigo metodo9 subClase2"'.
		
	self subclase2 compile: 
		'metodo7 "Codigo metodo7 subClase2"'.

	self subclase3 compile: 
		'metodo10 "Codigo metodo10 subClase3"'.
		
	self subclase3 compile: 
		'metodo8 "Codigo metodo8 subClase3"'.

	metodosRedefinidos := self utilidadComposicion metodosRedefinidosPorAlgunasDeTodasLasSubclasesDe: self claseAbstracta.
	
	claseComposicion := self utilidadComposicion crearClaseComposicionAPartirDe: self claseAbstracta  conElNombre: 'Composicion'.
	
	self utilidadComposicion agregarMetodosRedefinidos: metodosRedefinidos  DeLaClase: self claseAbstracta aLaComposicion: claseComposicion.
	
	self assert: (claseComposicion methodDictionary size = 0).
	
	claseComposicion removeFromSystem.
	
	self assert: (self claseAbstracta methodDictionary size = 5).
	self assert: ((self claseAbstracta methodDictionary at: #metodo1) getSource = 'metodo1 "Codigo metodo1 claseAbstracta"').
	self assert: ((self claseAbstracta methodDictionary at: #metodo2) getSource = 'metodo2 "Codigo metodo2 claseAbstracta"').
	self assert: ((self claseAbstracta methodDictionary at: #metodo3) getSource = 'metodo3 "Codigo metodo3 claseAbstracta"').
	self assert: ((self claseAbstracta methodDictionary at: #metodo4) getSource = 'metodo4 "Codigo metodo4 claseAbstracta"').
	self assert: ((self claseAbstracta methodDictionary at: #metodo5) getSource = 'metodo5 "Codigo metodo5 claseAbstracta"').
	
	
! !

!TestUtilidadDeComposicion methodsFor: 'as yet unclassified' stamp: 'Edu 5/3/2013 12:53'!
testClaseAbstractaSinSubclases
	|claseAbstractaPrueba resultado|
	claseAbstractaPrueba := (Object subclass: #ClaseAbstractaPrueba instanceVariableNames: '' classVariableNames: '' poolDictionaries: '' category: 'Meta').
	resultado := (self utilidadComposicion cambiarHerenciaPorComposicion: claseAbstractaPrueba conElNombre: 'Compo') not.
	claseAbstractaPrueba removeFromSystem.
	self assert: resultado.
	! !

!TestUtilidadDeComposicion methodsFor: 'as yet unclassified' stamp: 'Edu 5/3/2013 09:55'!
testConMetodosRedefinidos
	self claseAbstracta compile: 
		'metodo1 "Codigo metodo1 claseAbstracta"'.
		
	self claseAbstracta compile: 
		'metodo2 "Codigo metodo2 claseAbstracta"'.
	
	self claseAbstracta compile: 
		'metodo3 "Codigo metodo3 claseAbstracta"'.
	
	self claseAbstracta compile: 
		'metodo4 "Codigo metodo4 claseAbstracta"'.
		
	self claseAbstracta compile: 
		'metodo5 "Codigo metodo5 claseAbstracta"'.
	
	self subclase1 compile: 
		'metodo1 "Codigo metodo1 subClase1"'.
		
	self subclase1 compile: 
		'metodo3 "Codigo metodo3 subClase1"'.
		
	self subclase1 compile: 
		'metodo6 "Codigo metodo6 subClase1"'.

	self subclase2 compile: 
		'metodo2 "Codigo metodo2 subClase2"'.
		
	self subclase2 compile: 
		'metodo7 "Codigo metodo7 subClase2"'.

	self subclase3 compile: 
		'metodo4 "Codigo metodo4 subClase3"'.
		
	self subclase3 compile: 
		'metodo8 "Codigo metodo8 subClase3"'.

	self assert: (self utilidadComposicion metodosRedefinidosPorAlgunasDeTodasLasSubclasesDe: self claseAbstracta) = #(#metodo3 #metodo1 #metodo4 #metodo2).   ! !

!TestUtilidadDeComposicion methodsFor: 'as yet unclassified' stamp: 'Edu 5/3/2013 12:43'!
testReemplazarLlamadasAMetodosEliminados
	|codigoFuente codigoFuenteModificado|
	
	codigoFuente := 
		'metodoEjemploDeCodigoCon: fuerzas Y: masa
			|resultante aceleracion|
			
			resultante := fuerzas inject: resultante into: [:resul :fuerza | resul sumar: resul con: fuerza].
			
			aceleracion := resultante escalar: resultante con: (1/masa)
			
			^aceleracion'.
			
	codigoFuenteModificado := self utilidadComposicion reemplazarLlamadasAMetodos: #(#sumar:con: #escalar:con:) De: codigoFuente.
	
	self assert: (codigoFuenteModificado = 
	 'metodoEjemploDeCodigoCon: fuerzas Y: masa
			|resultante aceleracion|
			
			resultante := fuerzas inject: resultante into: [:resul :fuerza | resul composicion sumar: resul con: fuerza].
			
			aceleracion := resultante composicion escalar: resultante con: (1/masa)
			
			^aceleracion').
			
	codigoFuenteModificado := self utilidadComposicion reemplazarLlamadasAMetodos: #() De: codigoFuente.

	self assert: (codigoFuenteModificado = codigoFuente).
	! !

!TestUtilidadDeComposicion methodsFor: 'as yet unclassified' stamp: 'Edu 5/3/2013 10:05'!
testSinMetodosRedefinidos
	self claseAbstracta compile: 
		'metodo1 "Codigo metodo1 claseAbstracta"'.
		
	self claseAbstracta compile: 
		'metodo2 "Codigo metodo2 claseAbstracta"'.
	
	self claseAbstracta compile: 
		'metodo3 "Codigo metodo3 claseAbstracta"'.
	
	self claseAbstracta compile: 
		'metodo4 "Codigo metodo4 claseAbstracta"'.
		
	self claseAbstracta compile: 
		'metodo5 "Codigo metodo5 claseAbstracta"'.
	
	self subclase1 compile: 
		'metodo9 "Codigo metodo9 subClase1"'.
		
	self subclase1 compile: 
		'metodo8 "Codigo metodo8 subClase1"'.
		
	self subclase1 compile: 
		'metodo6 "Codigo metodo6 subClase1"'.

	self subclase2 compile: 
		'metodo8 "Codigo metodo8 subClase2"'.
		
	self subclase2 compile: 
		'metodo7 "Codigo metodo7 subClase2"'.

	self subclase3 compile: 
		'metodo9 "Codigo metodo9 subClase3"'.
		
	self subclase3 compile: 
		'metodo8 "Codigo metodo8 subClase3"'.

	self assert: (self utilidadComposicion metodosRedefinidosPorAlgunasDeTodasLasSubclasesDe: self claseAbstracta) = #().   ! !

!TestUtilidadDeComposicion methodsFor: 'accessing' stamp: 'Edu 5/2/2013 17:56'!
utilidadComposicion
	^ utilidadComposicion! !

!TestUtilidadDeComposicion methodsFor: 'accessing' stamp: 'Edu 5/2/2013 17:56'!
utilidadComposicion: anObject
	utilidadComposicion := anObject! !
